#include<LPC214x.h>
#include<string.h>
#include<stdio.h>
#include<stdlib.h>
#include "utilities.h"
#include "GLCD.h"
#include "first_page.h"
#include "TLJ_GFX.h"
#include "TLJ.h"
#include "Input.h"

struct player pl;
struct bullet pl_bullet[15];
struct bullet en_bullet[15];
struct troops troops;
struct boss boss;
char stage;
char input;
char flag;
char flline1,flline2,flline3,flboss;
char mrate,frate;

void input_select(void);
void pl_motion_control(void);
void Spawn_player(void);
void update_player_position(int position);
void pl_Fire(void);
void update_pl_bullet(void);
void init_pl_bullet(void);
void spawn_enemies(char stage);
void update_enemy_position(char stage);
void stage_updation(void);
void enemy_impact(void);
void init_en_bullet(void);
void en_Fire(void);
void update_en_bullet(void);
void enemy_motion(void);
void en_motion_rate(void);
void en_fire_rate(void);
void pl_impact(void);
void game_init(void);

int main()
{
	game_init();
	while(1)
	{
		en_motion_rate();
		pl_motion_control();
		if(Check_Fire){pl_Fire();}
		update_player_position(pl.position);
		update_enemy_position(stage);
		update_pl_bullet();
		en_fire_rate();
		update_en_bullet();
		enemy_impact();
		pl_impact();
		stage_updation();
		GLCD_DisplayBuffer();
		delay_ms(100);
		GLCD_Clear_Buffer();                                                                                                                                                                                                                                                                                                                         
	}
}

void input_select(void)
{
	joyy=get_JOYY_data();
	if(flag==0)
	{
		GLCD_64x8_inverted(joystick,1);
		GLCD_64x8(gesture,0);
		flag=1;
	}
	else
	{
		if(joyy>700)
		{
			input=0;
			GLCD_64x8_inverted(gesture,0);
			GLCD_64x8(joystick,1);
		}
		else if(joyy<100)
		{
			input=1;
			GLCD_64x8(gesture,0);
			GLCD_64x8_inverted(joystick,1);
		}
	}
	GLCD_DisplayBuffer();
}

void pl_motion_control(void)
{
	if(input==1)
	{
		joyx=get_JOYX_data();
		if(joyx < 100 )
		{
			if(pl.position>0){pl.position=pl.position-2;}
			else{pl.position=0;}
		}
		else if(joyx > 700)
		{
			if(pl.position<48){pl.position=pl.position+2;}
			else{pl.position=48;}
		}
	}
	else if(input==0)
	{
		gy=get_GY_data();
		if(gy>500)
		{
			if(pl.position>0){pl.position=pl.position-2;}
			else{pl.position=0;}
		}
		else if(gy<257)
		{
			if(pl.position<48){pl.position=pl.position+2;}
			else{pl.position=48;}
		}
	}
}

void update_player_position(int position)
{
	GLCD_SelectPage0();
	pl.pos_rem= position%8;
	pl.line = position/8;
	if(pl.alive)
	{
		if(pl.pos_rem==0)
		{
			GLCD_16x2(pl_1,pl.line,pl.cursor);
		}
		else if(pl.pos_rem==2)
		{
			GLCD_16x3(pl_2,pl.line,pl.cursor);
		}
		else if(pl.pos_rem==4)
		{
			GLCD_16x3(pl_3,pl.line,pl.cursor);
		}
		else if(pl.pos_rem==6)
		{
			GLCD_16x3(pl_4,pl.line,pl.cursor);
		}
	}
}

void Spawn_player(void)
{
	GLCD_SelectPage0();
	pl.line=3;
	pl.cursor=0;
	pl.strength=80;
	GLCD_16x2(pl_1,pl.line,pl.cursor);
	pl.position = pl_init_position;
	pl.alive = 1;
}

void pl_Fire(void)
{
	char i;
	for(i=0;i<15;i++)
	{
		if(!pl_bullet[i].alive)
		{
			pl_bullet[i].alive = 1;
			pl_bullet[i].cursor = 16;
			pl_bullet[i].init_position = pl.pos_rem;
			pl_bullet[i].line = pl.line+1;
			pl_bullet[i].position=((pl_bullet[i].line*8)+pl_bullet[i].init_position);
			break;
		}
	}
}

void update_pl_bullet(void)
{
	char i;
	for(i=0;i<15;i++)
	{
		if(pl_bullet[i].cursor>124){pl_bullet[i].alive=0;}
		if(pl_bullet[i].alive)
		{
			if(pl_bullet[i].init_position==0){GLCD_8x3(bullet_1,pl_bullet[i].line,pl_bullet[i].cursor);}
			else if(pl_bullet[i].init_position==2){GLCD_8x3(bullet_2,pl_bullet[i].line,pl_bullet[i].cursor);}
			else if(pl_bullet[i].init_position==4){GLCD_8x3(bullet_3,pl_bullet[i].line,pl_bullet[i].cursor);}
			else if(pl_bullet[i].init_position==6){GLCD_8x3(bullet_4,pl_bullet[i].line,pl_bullet[i].cursor);}
			pl_bullet[i].cursor+=3;
		}
	}
}

void init_pl_bullet(void)
{
	char i;
	for(i=0;i<15;i++){pl_bullet[i].alive=0;}
}

void spawn_enemies(char stage)
{
	int enline,position,i;
	if(stage<4)
	{
		for(enline=0;enline<3;enline++)
		{
			position=8;
			for(i=0;i<2;i++)
			{
				troops.enemy[enline][i].alive=1;
				troops.enemy[enline][i].position=position;
				troops.enemy[enline][i].enline=enline;
				troops.enemy[enline][i].line=(troops.enemy[enline][i].position/8);
				troops.enemy[enline][i].cursor=(127-(enline+1)*16);
				switch(stage)
				{
					case 1 : {GLCD_16x2(e1_1,troops.enemy[enline][i].line,troops.enemy[enline][i].cursor);flline1=1;flline2=0;flline3=1;troops.enemy[enline][i].strength=5;break;}
					case 2 : {GLCD_16x2(e2_1,troops.enemy[enline][i].line,troops.enemy[enline][i].cursor);flline1=1;flline2=0;flline3=1;troops.enemy[enline][i].strength=10;break;}
					case 3 : {GLCD_16x2(e3_1,troops.enemy[enline][i].line,troops.enemy[enline][i].cursor);flline1=1;flline2=0;flline3=1;troops.enemy[enline][i].strength=15;break;}
				}
				position=position+32;
				pl.position=pl_init_position;
			}
		}
	}
	else if(stage==4)
	{
		boss.alive=1;
		boss.cursor=87;
		boss.position=16;
		boss.strength=60;
		boss.line=(boss.position/8);
		GLCD_32x4(deathstar_1,boss.line,boss.cursor);
		Spawn_player();
	}
}

void update_enemy_position(char stage)
{
	int enline,pos_rem,i;
	if(stage<4)
	{
		for(enline=0;enline<3;enline++)
		{
			for(i=0;i<2;i++)
			{
				troops.enemy[enline][i].pos_rem=troops.enemy[enline][i].position%8;
				troops.enemy[enline][i].line=troops.enemy[enline][i].position/8;
				if(troops.enemy[enline][i].alive)
				{
					switch(troops.enemy[enline][i].pos_rem)
					{
					case 0:
						{
							switch(stage)
							{
								case 1 : {GLCD_16x2(e1_1,troops.enemy[enline][i].line,troops.enemy[enline][i].cursor);break;}
								case 2 : {GLCD_16x2(e2_1,troops.enemy[enline][i].line,troops.enemy[enline][i].cursor);break;}
								case 3 : {GLCD_16x2(e3_1,troops.enemy[enline][i].line,troops.enemy[enline][i].cursor);break;}
							}
							break;
						}
					case 2:
						{
							switch(stage)
							{
								case 1 : {GLCD_16x3(e1_2,troops.enemy[enline][i].line,troops.enemy[enline][i].cursor);break;}
								case 2 : {GLCD_16x3(e2_2,troops.enemy[enline][i].line,troops.enemy[enline][i].cursor);break;}
								case 3 : {GLCD_16x3(e3_2,troops.enemy[enline][i].line,troops.enemy[enline][i].cursor);break;}
							}
							break;
						}
					case 4:
						{
							switch(stage)
							{
								case 1 : {GLCD_16x3(e1_3,troops.enemy[enline][i].line,troops.enemy[enline][i].cursor);break;}
								case 2 : {GLCD_16x3(e2_3,troops.enemy[enline][i].line,troops.enemy[enline][i].cursor);break;}
								case 3 : {GLCD_16x3(e3_3,troops.enemy[enline][i].line,troops.enemy[enline][i].cursor);break;}
							}
							break;
						}
					case 6:
						{
							switch(stage)
							{
								case 1 : {GLCD_16x3(e1_4,troops.enemy[enline][i].line,troops.enemy[enline][i].cursor);break;}
								case 2 : {GLCD_16x3(e2_4,troops.enemy[enline][i].line,troops.enemy[enline][i].cursor);break;}
								case 3 : {GLCD_16x3(e3_4,troops.enemy[enline][i].line,troops.enemy[enline][i].cursor);break;}
							}
							break;
						}
					}
				}
				else if(!troops.enemy[enline][i].alive)
				{
					if(troops.enemy[enline][i].recent)
					{
						switch(pos_rem)
						{	
							case 0:{GLCD_16x2(exp_1,troops.enemy[enline][i].line,troops.enemy[enline][i].cursor);break;}
							case 2:{GLCD_16x3(exp_2,troops.enemy[enline][i].line,troops.enemy[enline][i].cursor);break;}
							case 4:{GLCD_16x3(exp_3,troops.enemy[enline][i].line,troops.enemy[enline][i].cursor);break;}
							case 6:{GLCD_16x3(exp_4,troops.enemy[enline][i].line,troops.enemy[enline][i].cursor);break;}
						}
						troops.enemy[enline][i].recent=0;
					}
				}
			}
		}
	}
	else if(stage==4)
	{
		boss.pos_rem=boss.position%8;
		boss.line=boss.position/8;
		if(boss.alive)
		{
			switch(pos_rem)
			{
				case 0: {GLCD_32x4(deathstar_1,boss.line,boss.cursor);break;}
				case 2: {GLCD_32x5(deathstar_2,boss.line,boss.cursor);break;}
				case 4: {GLCD_32x5(deathstar_3,boss.line,boss.cursor);break;}
				case 6: {GLCD_32x5(deathstar_4,boss.line,boss.cursor);break;}
			}
		}
	}
}

void stage_updation(void)
{
	if(stage<5)
	{
		if(troops.killed==6)
		{
			stage++;
			GLCD_Clear_Buffer();
			if(stage==2){GLCD_64x8(wave,1);GLCD_32x4(two,2,16);}
			else if (stage==3){GLCD_64x8(wave,1);GLCD_32x4(three,2,16);}
			else if (stage==4){GLCD_DisplayFullBitmap(unlearn);}
			GLCD_DisplayBuffer();
			delay_ms(2000);
			GLCD_Clear_Buffer();
			init_pl_bullet();
			init_en_bullet();
			spawn_enemies(stage);
			troops.killed=0;
		}
	}
	else if(stage==5)
	{
		GLCD_DisplayFullBitmap(jedi);
		GLCD_DisplayBuffer();
		delay_ms(2000);
		GLCD_Clear_Buffer();
		while(Check_pause);
		game_init();
	}
	else if(stage==6)
	{
		GLCD_DisplayFullBitmap(aware);
		GLCD_DisplayBuffer();
		delay_ms(2000);
		GLCD_Clear_Buffer();
		while(Check_pause);
		game_init();
	}
}

void enemy_impact(void)
{
	int i,j,enline;
	if(stage<4)
	{
		for(i=0;i<15;i++)
		{
			if(pl_bullet[i].alive)
			{
				for(enline=0;enline<3;enline++)
				{
					for(j=0;j<2;j++)
					{
						if(troops.enemy[enline][j].alive)
						{
							switch(stage)
							{
							case 1:
							{
								if(((pl_bullet[i].cursor+1)>=troops.enemy[enline][j].cursor) && ((pl_bullet[i].cursor+1)<(troops.enemy[enline][j].cursor+15)))
								{
									if((pl_bullet[i].position>=(troops.enemy[enline][j].position+4))&&(pl_bullet[i].position<(troops.enemy[enline][j].position+12)))
									{
										troops.enemy[enline][j].strength=(troops.enemy[enline][j].strength-1);
										pl_bullet[i].alive=0;
										if(troops.enemy[enline][j].strength==0)
										{
											troops.enemy[enline][j].alive=0;
											troops.enemy[enline][j].recent=1;
											troops.killed=troops.killed+1;
										}
									}
								}
								break;
							}	
							case 2:
							{
								if(((pl_bullet[i].cursor)>=troops.enemy[enline][j].cursor) && ((pl_bullet[i].cursor)<(troops.enemy[enline][j].cursor+15)))
								{
									if((pl_bullet[i].position>=(troops.enemy[enline][j].position+4))&&(pl_bullet[i].position<(troops.enemy[enline][j].position+12)))
									{
										troops.enemy[enline][j].strength=(troops.enemy[enline][j].strength-1);
										pl_bullet[i].alive=0;
										if(troops.enemy[enline][j].strength==0)
										{
											troops.enemy[enline][j].alive=0;
											troops.enemy[enline][j].recent=1;
											troops.killed=troops.killed+1;
										}
									}
								}
								break;
							}	
							case 3:
							{
								if(((pl_bullet[i].cursor)>=troops.enemy[enline][j].cursor) && ((pl_bullet[i].cursor)<(troops.enemy[enline][j].cursor+15)))
								{
									if((pl_bullet[i].position>=(troops.enemy[enline][j].position+6))&&(pl_bullet[i].position<(troops.enemy[enline][j].position+10)))
									{
										troops.enemy[enline][j].strength=(troops.enemy[enline][j].strength-1);
										pl_bullet[i].alive=0;
										if(troops.enemy[enline][j].strength==0)
										{
											troops.enemy[enline][j].alive=0;
											troops.enemy[enline][j].recent=1;
											troops.killed=troops.killed+1;
										}
									}
								}
								break;
							}
							}
						}
					}
				}
			}
		}
	}
	else if(stage==4)
	{
		for(i=0;i<15;i++)
		{
			if(pl_bullet[i].alive)
			{
				if(boss.alive)
				{
					if(((pl_bullet[i].position>=(boss.position+1)) && (pl_bullet[i].position<=(boss.position+8))) || (pl_bullet[i].position>=(boss.position+23) && (pl_bullet[i].position<=(boss.position+31))))
					{
						if((pl_bullet[i].cursor>(boss.cursor+2)) && (pl_bullet[i].cursor<=(boss.cursor+31)))
						{
							boss.strength=boss.strength-1;
							pl_bullet[i].alive=0;
						}
					}
					else if ((pl_bullet[i].position>=(boss.position+8)) && (pl_bullet[i].position<(boss.position+23)))
					{
						if((pl_bullet[i].cursor>(boss.cursor+11)) && (pl_bullet[i].cursor<=(boss.cursor+31)))
						{
							boss.strength=boss.strength-1;
							pl_bullet[i].alive=0;
						}	
					}
					if(boss.strength==0)
					{
						boss.alive=0;
						stage=5;
					}
				}
			}
		}
	}
}

void init_en_bullet(void)
{
	char i;
	for(i=0;i<15;i++){pl_bullet[i].alive=0;}
}

void en_Fire(void)
{
	char i;
	int enline,j;
	enline = rand()%3;
	j = rand()%2;
	if(stage<4)
	{
		if(troops.enemy[enline][j].alive)
		{
			for(i=0;i<15;i++)
			{
				if(!en_bullet[i].alive)
				{
					en_bullet[i].alive = 1;
					en_bullet[i].cursor = (troops.enemy[enline][j].cursor+3);
					en_bullet[i].init_position = troops.enemy[enline][j].pos_rem;
					en_bullet[i].line = troops.enemy[enline][j].line+1;
					en_bullet[i].position=((en_bullet[i].line*8)+en_bullet[i].init_position);
					break;
				}
			}
		}
	}
	else if(stage==4)
	{
		if(boss.alive)
		{
			for(i=0;i<15;i++)
			{
				if(!en_bullet[i].alive)
				{
					switch(enline)
					{
						case 0:
						{
							en_bullet[i].alive=1;
							en_bullet[i].cursor=(boss.cursor+3);
							en_bullet[i].init_position=((boss.position+6)%8);
							en_bullet[i].line=((boss.position+6)/8);
							en_bullet[i].position=((en_bullet[i].line*8)+en_bullet[i].init_position);
							break;
						}
						case 1:
						{
							en_bullet[i].alive=1;
							en_bullet[i].cursor=(boss.cursor+12);
							en_bullet[i].init_position=((boss.position+16)%8);
							en_bullet[i].line=((boss.position+16)/8);
							en_bullet[i].position=((en_bullet[i].line*8)+en_bullet[i].init_position);
							break;
						}
						case 2:
						{
							en_bullet[i].alive=1;
							en_bullet[i].cursor=(boss.cursor+3);
							en_bullet[i].init_position=((boss.position+24)%8);
							en_bullet[i].line=((boss.position+24)/8);
							en_bullet[i].position=((en_bullet[i].line*8)+en_bullet[i].init_position);
							break;
						}
					}
					break;
				}
			}
		}
	}
}

void update_en_bullet(void)
{
	char i;
	for(i=0;i<15;i++)
	{
		if(en_bullet[i].cursor<3){en_bullet[i].alive=0;}
		if(en_bullet[i].alive)
		{
			if(en_bullet[i].init_position==0){GLCD_8x3(bullet_1,en_bullet[i].line,en_bullet[i].cursor);}
			else if(en_bullet[i].init_position==2){GLCD_8x3(bullet_2,en_bullet[i].line,en_bullet[i].cursor);}
			else if(en_bullet[i].init_position==4){GLCD_8x3(bullet_3,en_bullet[i].line,en_bullet[i].cursor);}
			else if(en_bullet[i].init_position==6){GLCD_8x3(bullet_4,en_bullet[i].line,en_bullet[i].cursor);}
			en_bullet[i].cursor-=1;
		}
	}
}

void enemy_motion(void)
{
	char enline;
	if(stage<4)
	{
		for(enline=0;enline<3;enline++)
		{
			switch(enline)
			{
				case 0:
				{
					if(flline1)
					{
						troops.enemy[enline][0].position+=2;
						troops.enemy[enline][1].position+=2;
						if(troops.enemy[enline][1].alive)
						{
							if(troops.enemy[enline][1].position==48){flline1=0;}
						}
						else if (!troops.enemy[enline][1].alive)
						{
							if(troops.enemy[enline][0].position==48){flline1=0;}
						}
					}
					else if(!flline1)
					{
						troops.enemy[enline][0].position-=2;
						troops.enemy[enline][1].position-=2;
						if(troops.enemy[enline][0].alive)
						{
							if(troops.enemy[enline][0].position==0){flline1=1;}
						}
						else if(!troops.enemy[enline][0].alive)
						{
							if(troops.enemy[enline][1].position==0){flline1=1;}
						}
					}
					break;
				}
				case 1:
				{
					if(flline2)
					{
						troops.enemy[enline][0].position+=2;
						troops.enemy[enline][1].position+=2;
						if(troops.enemy[enline][1].alive)
						{
							if(troops.enemy[enline][1].position==48){flline2=0;}
						}
						else if (!troops.enemy[enline][1].alive)
						{
							if(troops.enemy[enline][0].position==48){flline2=0;}
						}
					}
					else if(!flline2)
					{
						troops.enemy[enline][0].position-=2;
						troops.enemy[enline][1].position-=2;
						if(troops.enemy[enline][0].alive)
						{
							if(troops.enemy[enline][0].position==0){flline2=1;}
						}
						else if(!troops.enemy[enline][0].alive)
						{
							if(troops.enemy[enline][1].position==0){flline2=1;}
						}
					}
					break;
				}
				case 2:
					{
					if(flline3)
					{
						troops.enemy[enline][0].position+=2;
						troops.enemy[enline][1].position+=2;
						if(troops.enemy[enline][1].alive)
						{
							if(troops.enemy[enline][1].position==48){flline3=0;}
						}
						else if (!troops.enemy[enline][1].alive)
						{
							if(troops.enemy[enline][0].position==48){flline3=0;}
						}
					}
					else if(!flline3)
					{
						troops.enemy[enline][0].position-=2;
						troops.enemy[enline][1].position-=2;
						if(troops.enemy[enline][0].alive)
						{
							if(troops.enemy[enline][0].position==0){flline3=1;}
						}
						else if(!troops.enemy[enline][0].alive)
						{
							if(troops.enemy[enline][1].position==0){flline3=1;}
						}
					}
					break;
				}
			}
		}
	}
	else if(stage==4)
	{
		if(flboss)
		{
			boss.position+=2;
			if(boss.position==32){flboss=0;}
		}
		else if(!flboss)
		{
			boss.position-=2;
			if(boss.position==0){flboss=1;}
		}
	}
}

void en_motion_rate(void)
{
	mrate++;
	switch(stage)
	{
		case 1: if(mrate==16){enemy_motion();mrate=0;}
		case 2: if(mrate==12){enemy_motion();mrate=0;}
		case 3: if(mrate==8){enemy_motion();mrate=0;}
		case 4: if(mrate==4){enemy_motion();mrate=0;}
	}
}

void en_fire_rate(void)
{
	frate++;
	switch(stage)
	{
		case 1: if(frate==8){en_Fire();frate=0;}
		case 2: if(frate==6){en_Fire();frate=0;}
		case 3: if(frate==4){en_Fire();frate=0;}
		case 4: if(frate==2){en_Fire();frate=0;}
	}
}

void pl_impact(void)
{
	int i;
	for(i=0;i<15;i++)
	{
		if(pl.alive)
		{
			if((en_bullet[i].position>(pl.position+6)) && (en_bullet[i].position<(pl.position+11)))
			{
				if((en_bullet[i].cursor<(pl.cursor+13)) && (en_bullet[i].cursor>(pl.cursor+1)))
				{
					en_bullet[i].alive=0;
					pl.strength=pl.strength-1;
				}
			}
			else if(((en_bullet[i].position>(pl.position+2)) && (en_bullet[i].position<=(pl.position+6))) || ((en_bullet[i].position>=(pl.position+11)) && (en_bullet[i].position<=(pl.position+14))))
			{
				if((en_bullet[i].cursor<(pl.cursor+10)) && (en_bullet[i].cursor>(pl.cursor+1)))
				{
					en_bullet[i].alive=0;
					pl.strength=pl.strength-1;
				}
			}
			if(pl.strength==0)
			{
				pl.alive=0;
				stage=6;
			}
		}
	}
}

void game_init(void)
{
	flag=0;
	stage=1;
	input=1;
	flline1=1;
	flline2=0;
	flline3=1;
	flboss=1;
	mrate=0;
	frate=0;
	ADC_Init();
	GLCD_init();
	delay_us(1000);
	GLCD_DisplayFullBitmap(THE_LAST_JEDI_MONO);
	GLCD_DisplayBuffer();
	delay_ms(5000);
	GLCD_Clear_Buffer();
	while(Check_pause){input_select();}
	GLCD_Clear_Buffer();
	GLCD_DisplayFullBitmap(May);
	GLCD_DisplayBuffer();
	delay_ms(5000);
	GLCD_Clear_Buffer();
	GLCD_64x8(wave,1);
	GLCD_32x4(one,2,16);
	GLCD_DisplayBuffer();
	delay_ms(2000);
	GLCD_Clear_Buffer();
	
	Spawn_player();
	init_pl_bullet();	
	init_en_bullet();
	spawn_enemies(stage);
}
